<?php
class AddPermissions extends DBMigration
{
	function up()
	{
		// Add index on hash column
		$this->db->query("ALTER TABLE user_statistics DROP INDEX hash");
		$this->db->query("ALTER TABLE user_statistics ADD INDEX hash(hash)");
		// Add permission column
		$this->db->query("ALTER TABLE user_statistics ADD COLUMN permission SET('unknown', 'student', 'teacher', 'admin') NOT NULL DEFAULT 'unknown'");

		// Reconstruct permissions from hashes (may take a while)
		$permissions = array(
			'root'=>'admin',
			'admin'=>'admin',
			'dozent'=>'teacher',
			'tutor'=>'student',
			'autor'=>'student',
			'user'=>'student'
		);

		$data = array();
		$this->db->queryf("SELECT DISTINCT hash FROM user_statistics WHERE permission='unknown'");
		while ($this->db->next_record())
		{
			$data[$this->db->f('hash')] = 'unknown';
		}
		$this->db->free();

		$this->db->queryf("SELECT perms, hash FROM (SELECT perms, MD5(CONCAT(user_id, username)) AS hash FROM auth_user_md5) AS tmp_user WHERE hash IN('%s')", implode("','", array_keys($data)));
		while ($this->db->next_record())
		{
			$data[$this->db->f('hash')] = isset($permissions[$this->db->f('perms')]) ? $permissions[$this->db->f('perms')] : 'unknown';
		}
		$this->db->free();

		foreach ($data as $hash=>$permission)
		{
			if ($permission=='unknown')
			{
				continue;
			}
			$this->db->queryf("UPDATE user_statistics SET permission='%s' WHERE hash='%s'", $permission, $hash);
		}

		// Optimize table
		$this->db->queryf("OPTIMIZE table user_statistics");
	}

	function down()
	{
		$this->db->query("ALTER TABLE user_statistics DROP COLUMN permission");
		$this->db->query("ALTER TABLE user_statistics DROP INDEX hash");
	}
}
?>
