<?php
class HashIp extends DBMigration
{
	function up()
	{
		// Hash IP as MD5
		$this->db->queryf("ALTER TABLE user_statistics ADD COLUMN tmp_ip CHAR(32) NOT NULL DEFAULT ''");
		$this->db->queryf("UPDATE user_statistics SET tmp_ip=MD5(ip)");
		$this->db->queryf("ALTER TABLE user_statistics DROP PRIMARY KEY, DROP COLUMN ip, CHANGE COLUMN tmp_ip ip CHAR(32) NOT NULL DEFAULT '' FIRST, ADD PRIMARY KEY (ip, user_agent, daystamp, hash)");

		// Add index for daystamp
		$this->db->queryf("ALTER TABLE user_statistics ADD KEY daystamp (daystamp)");

		// Optimize
		$this->db->queryf("OPTIMIZE TABLE user_statistics");
	}

	function down()
	{
		// Drop index for daystamp
		$this->db->queryf("ALTER TABLE user_statistics DROP KEY daystamp");

		// Hashing is not reversible

		// Optimize
		$this->db->queryf("OPTIMIZE TABLE user_statistics");
	}
}
?>